//+-------------------------------------------------------------------------+
//|                                 ....mq4                                 |
//|                                 Copyright  2010, O.Konovalov aka Regul |
//+-------------------------------------------------------------------------+
#property copyright "Copyright  2010 O.Konovalov aka Regul"
#property link      "E-mail:RegulStar@gmail.com"

#property indicator_chart_window
#property indicator_buffers 6

#property indicator_color1 DeepSkyBlue
#property indicator_color2 DeepPink
#property indicator_color3 DeepSkyBlue
#property indicator_color4 DeepPink
#property indicator_color5 DeepSkyBlue
#property indicator_color6 DeepPink

#property indicator_width1 1
#property indicator_width2 1
#property indicator_width3 1
#property indicator_width4 1
#property indicator_width5 2
#property indicator_width6 2
//----
extern color color1 = DeepSkyBlue;
extern color color2 = DeepPink;
extern color color3 = DeepSkyBlue;
extern color color4 = DeepPink;
extern color color5 = DeepSkyBlue;
extern color color6 = DeepPink;

//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];
double ExtMapBuffer5[];
double ExtMapBuffer6[];
double ExtMapBuffer7[];
double ExtMapBuffer8[];

//---       
   IndicatorShortName("...");
   //---
   SetIndexLabel(0, "IBB");
   SetIndexLabel(1, "IBS");
   SetIndexLabel(2, "TBB"); 
   SetIndexLabel(3, "TBS"); 
   SetIndexLabel(4, "FBB");
   SetIndexLabel(5, "FBS"); 
   SetIndexLabel(6, "...");
   SetIndexLabel(7, "...");
//----
int ExtCountedBars=0;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//|------------------------------------------------------------------|
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_ARROW,color1);
   SetIndexArrow(0,159);
   SetIndexBuffer(0, ExtMapBuffer1);
   
   SetIndexStyle(1,DRAW_ARROW,color2);
   SetIndexArrow(1,159);
   SetIndexBuffer(1, ExtMapBuffer2);
   
   SetIndexStyle(2,DRAW_ARROW,color3);
   SetIndexArrow(2,167);
   SetIndexBuffer(2, ExtMapBuffer3);
   
   SetIndexStyle(3,DRAW_ARROW,color4);
   SetIndexArrow(3,167);
   SetIndexBuffer(3, ExtMapBuffer4);
   
   SetIndexStyle(4,DRAW_ARROW,color5);
   SetIndexArrow(4,217);
   SetIndexBuffer(4, ExtMapBuffer5);
   
   SetIndexStyle(5,DRAW_ARROW,color6);
   SetIndexArrow(5,218);
   SetIndexBuffer(5, ExtMapBuffer6);
//----
   SetIndexDrawBegin(0,10);
   SetIndexDrawBegin(1,10);
   SetIndexDrawBegin(2,10);
   SetIndexDrawBegin(3,10);
   SetIndexDrawBegin(4,10);
   SetIndexDrawBegin(5,10);
   

//---- indicator buffers mapping
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexBuffer(2,ExtMapBuffer3);
   SetIndexBuffer(3,ExtMapBuffer4);
   SetIndexBuffer(4,ExtMapBuffer5);
   SetIndexBuffer(5,ExtMapBuffer6);
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- TODO: add your code here
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS));
   string symbol=Symbol();
   string urrency=AccountCurrency();
   double IBB, IBS, TBB, TBS, FBB, FBS;
   if(Bars<=10) return(0);
   ExtCountedBars=IndicatorCounted();
//---- check for possible errors
   if (ExtCountedBars<0) return(-1);
//---- last counted bar will be recounted
   if (ExtCountedBars>0) ExtCountedBars--;
   int pos=Bars-ExtCountedBars-1;
   while(pos>=0)
     {
     //-------- ---------------------------
      double ask=MarketInfo(symbol,MODE_ASK);
      double bid=MarketInfo(symbol,MODE_BID);
      double margin_free=AccountFreeMargin();
      double margin_buy=MarketInfo(symbol,MODE_MARGINREQUIRED);
      double margin_sell=0; if (ask>0) margin_sell=NormalizeDouble(margin_buy*bid/ask,2);
      double lots_buy =0;
      double lots_sell=0;
      if (margin_buy >0 && margin_free>0) lots_buy =margin_free/margin_buy ;
      if (margin_sell>0 && margin_free>0) lots_sell=margin_free/margin_sell;
      double minlot=MarketInfo(symbol,MODE_MINLOT);
      double maxlot=MarketInfo(symbol,MODE_MAXLOT);
      int count_buy =0; if (minlot>0) count_buy =lots_buy /minlot;
      int count_sell=0; if (minlot>0) count_sell=lots_sell/minlot;
      lots_buy =minlot*count_buy ;
      lots_sell=minlot*count_sell;
      double tickvalue=MarketInfo(symbol,MODE_TICKVALUE);
      double swap_buy =0; if (minlot>0) swap_buy =MarketInfo(symbol,MODE_SWAPLONG )/minlot;
      double swap_sell=0; if (minlot>0) swap_sell=MarketInfo(symbol,MODE_SWAPSHORT)/minlot;
      double swap_buy_ticks =0; if (tickvalue>0) swap_buy_ticks =swap_buy /tickvalue;
      double swap_sell_ticks=0; if (tickvalue>0) swap_sell_ticks=swap_sell/tickvalue;
      string type=""; if(IsDemo()) type="";
      string market;
      int margin_mode=MarketInfo(symbol,MODE_MARGINCALCMODE);
      switch (margin_mode) 
      {
         case 0 : market="Forex"  ; break;
         case 1 : market="CFD"    ; break;
         case 2 : market="Futures"; break;
         case 3 : market="Indexes"; break;
      }
      
      Comment(
              //" : ",type,
              "\n",": ",AccountLeverage(),
              //"\n"," : ",DoubleToStr(deposit,2)," ",urrency,
              //"\n","  : ",DoubleToStr(withdrawal,2)," ",urrency,
              "\n",": ",DoubleToStr(AccountBalance(),2)," ",urrency,
              "\n",": ",DoubleToStr(AccountEquity(),2)," ",urrency,
              //"\n",": ",symbol,
              //"\n",": ",market,
              "\n","   BUY : ",DoubleToStr(lots_buy,2),
              "\n","   SELL: ",DoubleToStr(lots_sell,2),
              "\n","  1   BUY : ",DoubleToStr(margin_buy ,2)," ",urrency,
              "\n","  1   SELL: ",DoubleToStr(margin_sell,2)," ",urrency,
              "\n","  1   BUY : ",DoubleToStr(swap_buy,2)," ",urrency," (",DoubleToStr(swap_buy_ticks,2)," pips)",
              "\n","  1   SELL: ",DoubleToStr(swap_sell,2)," ",urrency," (",DoubleToStr(swap_sell_ticks,2)," pips)",
              //"\n"+"   : "+DoubleToStr(tickvalue,2)+" "+urrency+" (1 pips)",
              //"\n"+" : "+DoubleToStr(minlot,1),
              //"\n"+" : "+DoubleToStr(maxlot,1),
              //"\n"+": "+DoubleToStr(MarketInfo(symbol,MODE_POINT),MarketInfo(symbol,MODE_DIGITS)),
              //"\n"+": "+DoubleToStr(MarketInfo(symbol,MODE_DIGITS),0),
              "\n"+": "+DoubleToStr(MarketInfo(symbol,MODE_SPREAD),0),
              "\n"+" : "+DoubleToStr(MarketInfo(symbol,MODE_STOPLEVEL),0)
              );
      //-----------------------------------------  
      if (Close[pos+1]-High[pos+2]>0) IBB=High[pos+1]; else IBB=-1;
      if (Close[pos+1]-Low[pos+2]<0) IBS=Low[pos+1]; else IBS=-1;
      //TBB=; 
      //TBS=;
      FBB=High[pos+1]; FBS=Low[pos+1];
      if (IBB>0) ExtMapBuffer5[pos+1]=FBB; else ExtMapBuffer5[pos+1]=0;
      if (IBS>0) ExtMapBuffer6[pos+1]=FBS; else ExtMapBuffer6[pos+1]=0;

      ExtMapBuffer1[pos+1]=IBB;
      ExtMapBuffer2[pos+1]=IBS;
      ExtMapBuffer3[pos+1]=TBB;
      ExtMapBuffer4[pos+1]=TBS;
      
 	   pos--;
     }
//----
   return(0);
  }
//+------------------------------------------------------------------+